// Generated by CoffeeScript 1.11.1
(function() {
  var CSSWorker, assign, debug, fs, helpers, path, processors;

  path = require('path');

  fs = require('fs');

  assign = require('lodash.assign');

  debug = require('debug');

  CSSWorker = require('../../utils/cssworker');

  helpers = require('../../helpers');

  debug = debug('fedor:css');


  /**
   * Build Processor list for stylesheets.
   *
   * same as doing...
   *
   *    var processors = {
   *      "less"   : require("./less"),
   *      "stylus" : require("./stylus")
   *    }
   */

  processors = {};

  helpers.processors['css'].forEach(function(sourceType) {
    return processors[sourceType] = require("./" + sourceType);
  });

  module.exports = function(filePath, config, callback) {
    var baseDir, ext, ref, srcPath;
    if (config == null) {
      config = {};
    }
    baseDir = path.resolve((ref = config.baseDir) != null ? ref : '.');
    srcPath = path.resolve(baseDir, filePath);
    ext = helpers.extname(srcPath);
    return fs.readFile(srcPath, function(err, data) {
      var dirs, render;
      if (err && err.code === 'ENOENT') {
        return callback(null, null);
      }
      if (err) {
        return callback(err);
      }
      dirs = [path.dirname(srcPath), path.dirname(path.resolve(baseDir))];
      return render = processors[ext].compile(srcPath, dirs, data, function(err, source, sourcemap) {
        var cssworker;
        if (err) {
          return callback(err);
        }
        cssworker = CSSWorker.create(assign({
          basePath: baseDir,
          env: config.env
        }, config.css));
        return cssworker.process(source, {
          filename: srcPath,
          sourcemap: sourcemap
        }).then(function(result) {
          result.warnings().forEach(function(s) {
            return console.warn(s.toString());
          });
          return callback(null, result.css, result.map);
        })["catch"](function(e) {
          return callback(e, null);
        });
      });
    });
  };

}).call(this);
