// Generated by CoffeeScript 1.11.1
(function() {
  var TerraformError, sass;

  sass = require('node-sass');

  TerraformError = require('../../helpers').TerraformError;

  exports.compile = function(filePath, dirs, fileContents, callback) {
    var opts;
    opts = {
      file: filePath,
      includePaths: dirs,
      outputStyle: 'nested',
      sourceMap: true,
      sourceMapEmbed: false,
      sourceMapContents: true,
      outFile: filePath,
      omitSourceMapUrl: true
    };
    return sass.render(opts, function(e, css) {
      if (e) {
        return callback(new TerraformError({
          source: 'Sass',
          dest: 'CSS',
          lineno: e.line || 99,
          name: 'Sass Error',
          message: e.message,
          filename: e.file || filePath,
          stack: fileContents.toString()
        }));
      }
      return callback(null, css.css, css.map.toString());
    });
  };

}).call(this);
