// Generated by CoffeeScript 1.11.1
(function() {
  var TerraformError, stylus;

  stylus = require('stylus');

  TerraformError = require('../../helpers').TerraformError;

  exports.compile = function(filePath, dirs, fileContents, callback) {
    var style;
    style = stylus(fileContents.toString());
    style.set('filename', filePath);
    style.set('paths', dirs);
    style.set('compress', false);
    style.set('include css', true);
    style.set('sourcemap', {
      'comment': false,
      'inline': false
    });
    return style.render(function(err, css) {
      var arr, arr2, chunks, error, path_arr;
      if (err) {
        chunks = err.message.split('\n\n');
        arr = chunks[0].split('\n');
        err.filename = parseInt(arr[0].split(':')[0] || -1);
        path_arr = arr[0].split(':');
        err.lineno = parseInt(err.lineno || path_arr[path_arr.length - 2] || -1);
        arr2 = chunks[1].split('\n');
        err.message = arr2[0].replace(/"/g, '\"');
        err.source = 'Stylus';
        err.dest = 'CSS';
        err.name = 'Stylus Error';
        err.filename = filePath;
        err.stack = fileContents.toString();
        error = new TerraformError(err);
      }
      return callback(error, css, style.sourcemap);
    });
  };

}).call(this);
