// Generated by CoffeeScript 1.11.1
(function() {
  var UGLIFY_DEFAULT, browserify, checkPattern, debug, extend, extensions, fs, helpers, minify, moduleCache, p, processors, stattag, through, uglifyjs,
    slice = [].slice;

  fs = require('fs');

  p = require('path');

  browserify = require('browserify');

  through = require('through');

  helpers = require('../../helpers');

  uglifyjs = require('uglify-js');

  debug = require('debug')('fedor:worker');

  checkPattern = helpers.checkPattern;

  moduleCache = require('lru-cache')(200);

  extend = function() {
    var args, i, k, len, r, s;
    r = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    for (i = 0, len = args.length; i < len; i++) {
      s = args[i];
      for (k in s) {
        if (Object.prototype.hasOwnProperty.call(s, k)) {
          r[k] = s[k];
        }
      }
    }
    return r;
  };

  stattag = function(file) {
    var e, mtime, size, stat;
    try {
      stat = fs.statSync(file);
      mtime = stat.mtime.getTime().toString(16);
      size = stat.size.toString(16);
      return size + "-" + mtime;
    } catch (error) {
      e = error;
      return null;
    }
  };


  /**
   * Build Processor list for javascripts.
   *
   * same as doing...
   *
   *    var processors = {
   *      'coffee' : require('./coffee')
   *    }
   */

  processors = {};

  extensions = [];

  helpers.processors['js'].forEach(function(sourceType) {
    extensions.push('.' + sourceType);
    return processors[sourceType] = require("./" + sourceType);
  });

  UGLIFY_DEFAULT = {
    warnings: false,
    output: {
      beautify: false,
      comments: function(node, comment) {
        var text, type;
        type = comment.type;
        text = comment.value;
        if (type === 'comment2') {
          return /^!|@preserve|@license|@cc_on/i.test(text);
        }
      },
      screw_ie8: false
    },
    compress: {
      sequences: true,
      join_vars: true,
      hoist_vars: true,
      global_defs: {
        DEBUG: false
      },
      screw_ie8: false
    },
    mangle: {
      screw_ie8: false
    }
  };

  minify = function(source, config) {
    var opts, result;
    opts = config.uglifyjs || UGLIFY_DEFAULT;
    if (config.enable === true) {
      debug("compress => " + opts.filename);
      opts.fromString = true;
      result = uglifyjs.minify(source, opts);
      return result.code;
    } else {
      debug("minify cancelled. (" + opts.filename + ")");
      return source;
    }
  };

  module.exports = function(filePath, config, callback) {
    var baseDir, ext, ref, srcPath;
    if (config == null) {
      config = {};
    }
    baseDir = p.resolve((ref = config.baseDir) != null ? ref : '.');
    srcPath = p.resolve(baseDir, filePath);
    ext = helpers.extname(srcPath);
    return fs.readFile(srcPath, function(e, data) {
      var b, babelOpts, browserifyOpts, bundle, jsOpts, minifyOpts, onError, ref1, render, result;
      if (e && e.code === 'ENOENT') {
        return callback(null, null);
      }
      if (e) {
        return callback(e);
      }
      babelOpts = config.babel || {
        pattern: ['**/*.es6', '**/*.es']
      };
      jsOpts = config.js || {};
      minifyOpts = jsOpts.minify || {};
      minifyOpts.uglifyjs = extend({
        fromString: true,
        filename: filePath
      }, UGLIFY_DEFAULT, minifyOpts.uglifyjs);
      browserifyOpts = (ref1 = config.browserify) != null ? ref1 : 0;
      debug('build => %s', filePath);
      data = data.toString();
      render = function(type, source, fn) {
        var pattern;
        pattern = babelOpts.pattern;
        if (type === 'js' && pattern && checkPattern(filePath, pattern)) {
          type = 'es';
        }
        return processors[type].compile(srcPath, source, function(e, result) {
          return fn(e, e ? e : result);
        });
      };
      if (checkPattern(filePath, browserifyOpts.pattern) && helpers.needsBrowserify(data)) {
        debug('browserify => %s', filePath);
        onError = function(e) {
          console.error('Browserify Error =>', e);
          callback(e, data);
        };
        b = browserify(srcPath, {
          extensions: extensions
        }).transform(function(file) {
          var end, enqueue, sb, stream, write;
          sb = '';
          write = function(d) {
            return sb += d;
          };
          stream = null;
          enqueue = function(s) {
            stream.queue(s);
            stream.queue(null);
          };
          end = function() {
            var cache, key;
            stream = this;
            key = file + '-' + stattag(file);
            cache = moduleCache.get(key);
            debug("-> %s", p.relative(baseDir, file));
            if (cache) {
              enqueue(cache);
            } else {
              render(helpers.extname(file), sb, (function(_this) {
                return function(e, result) {
                  if (!e) {
                    moduleCache.set(key, result);
                  }
                  enqueue(result);
                };
              })(this));
            }
          };
          return through(write, end);
        });
        result = '';
        bundle = b.bundle().on('data', function(d) {
          return result += d;
        }).on('error', onError).on('end', function() {
          try {
            result = minify(result, minifyOpts);
          } catch (error) {
            e = error;
            e.stack = srcPath;
            console.error(e);
          }
          callback(null, result);
        });
      } else {
        render(ext, data, function(e, result) {
          result = minify(result, minifyOpts);
          callback(e, result);
        });
      }
    });
  };

}).call(this);
